#Тема 8 Лазарев Данил А-01-23
#1 Запуск интерактивной оболочки IDLE
```
import os
os.chdir("C:\\Users\\Dannyan\\OneDrive\\Рабочий стол\\python-labs\\TEMA9")
os.getcwd()
>> 'C:\\Users\\Dannyan\\OneDrive\\Рабочий стол\\python-labs\\TEMA9'
```
#2 Создание классов и их наследников
## 2.1. Создание автономного класса
Создадим класс с именем Class1, содержащий 2 функции, реализующие его методы.
class Class1: # Объявление класса
    def zad_zn(self, znach): # Метод класса для задания значения поля data
        self.data = znach
    def otobrazh(self): # Метод класса для отображения значения поля data
        print(self.data)
     
z1 = Class1() # Создание 1-го экземпляра класса
z2 = Class1() # Создание 2-го экземпляра класса
z1.zad_zn("Экземпляр класса 1")
z2.zad_zn(-632.453)
z1.otobrazh()
>> Экземпляр класса 1
z2.otobrazh()
>> -632.453
z1.data = "Новое значение атрибута у экземпляра 1"
z1.otobrazh()
>> Новое значение атрибута у экземпляра 1
## 2.2. Создание класса-наследника
```
class Class2(Class1):  #Class2 - наследник класса Class1 
    def otobrazh(self):     # Метод  класса Class2 – переопределяет метод родителя 
        print('значение=',self.data)#Отображение данных экземпляра

        
z3=Class2()
dir(z3)
>> ['__class__', '__delattr__', '__dict__', '__dir__', '__doc__', '__eq__', '__firstlineno__', '__format__', '__ge__', '__getattribute__', '__getstate__', '__gt__', '__hash__', '__init__', '__init_subclass__', '__le__', '__lt__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__static_attributes__', '__str__', '__subclasshook__', '__weakref__', 'otobrazh', 'zad_zn']
z3.zad_zn('Совсем новое')
z3.otobrazh()
>> значение= Совсем новое
z1.otobrazh()
>> Новое значение атрибута у экземпляра 1
del  z1,z2,z3
```
#3 Использование классов, содержащихся в модулях
Создание модуля
```
class Class1:               #Объявление класса Class1 в модуле 
    def zad_zn(self,znach): # 1 Метод класса 
        self.data=znach # self - ссылка на экземпляр класса Class1 
    def otobrazh(self):     # 2 Метод класса 
        print(self.data)#Отображение данных экземпляра 
class Class2(Class1):  #Class2 - наследник класса Class1 
    def otobrazh(self):     # Метод  класса Class2 
        print('значение=',self.data)#Отображение данных экземпляра 
def otobrazh(objekt):  #Объявление самостоятельной функции 
    print('значение объекта=',objekt) 
```
ddd
```
from Mod3 import Class1
z4=Class1()
z4.otobrazh()
>> Traceback (most recent call last):
  File "<pyshell#25>", line 1, in <module>
    z4.otobrazh()
  File "C:\Users\Dannyan\OneDrive\Рабочий стол\python-labs\TEMA9\Mod3.py", line 5, in otobrazh
    print(self.data)#Отображение данных экземпляра
AttributeError: 'Class1' object has no attribute 'data'
from Mod3 import Class1
z4=Class1()
z4.data='значение данного data у экз.4'
z4.otobrazh()
>> значение данного data у экз.4
import Mod3  #Полный импорт содержимого модуля
z4=Mod3.Class2()
z4.zad_zn('Класс из модуля')
z4.otobrazh()
>> значение= Класс из модуля
Mod3.otobrazh('Объект')
>> значение объекта= Объект
```
#4 Использование специвльных методов
Имена специальных методов предваряются одним или двумя подчерками и имеют вид: __<имя специального метода>__

Для примера создайте класс, содержащий два специальных метода
```
class Class3(Class2):  #Наследник класса Class2, а через него – и класса Class1 
    def __init__(self,znach): #Конструктор-вызывается при создании нового экземпляра класса 
        self.data=znach 
    def __add__(self,drug_zn):  #Вызывается, когда экземпляр участвует в операции «+» 
        return Class3(self.data+drug_zn) 
    def zad_dr_zn(self,povtor):  #А это - обычный метод 
        self.data*=povtor
```
Метод __add__ - это один из методов, осуществляющих так называемую «перегрузку» операторов.
Для иллюстрации работы этих методов создайте экземпляр класса Class3 и отобразите его
```
z5=Class3('abc') #При создании экземпляра срабатывает конструктор
z5.otobrazh()
>> значение= abc
```
А теперь выполните операцию «+» (должен сработать специальный метод __add__)
```
z6=z5+'def'
z6.otobrazh()
>> значение= abcdef
```
Ну и наконец, обратитесь к обычному методу класса:
```
z6.zad_dr_zn(3) 
z6.otobrazh()
>> значение= abcdefabcdefabcdef
```
#5 Присоединение атрибутов к классу
```
dir(Class3)
>> ['__add__', '__class__', '__delattr__', '__dict__', '__dir__', '__doc__', '__eq__', '__firstlineno__', '__format__', '__ge__', '__getattribute__', '__getstate__', '__gt__', '__hash__', '__init__', '__init_subclass__', '__le__', '__lt__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__static_attributes__', '__str__', '__subclasshook__', '__weakref__', 'otobrazh', 'zad_dr_zn', 'zad_zn']
Class3.fio='Иванов И.И.'
z7=Class3(123)
dir(z7)==dir(Class3)
>> False
dir(z7)
>> ['__add__', '__class__', '__delattr__', '__dict__', '__dir__', '__doc__', '__eq__', '__firstlineno__', '__format__', '__ge__', '__getattribute__', '__getstate__', '__gt__', '__hash__', '__init__', '__init_subclass__', '__le__', '__lt__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__static_attributes__', '__str__', '__subclasshook__', '__weakref__', 'data', 'fio', 'otobrazh', 'zad_dr_zn', 'zad_zn']
z7.fio
>> 'Иванов И.И.'
Class3.fio
>> 'Иванов И.И.'
z7.rozden = "1987"
"rozden" in dir(z7)
>> True
"rozden" in dir(Class3)
>> False
```
#6 Выявление родительских классов
Такое выявление делается с помощью специального атрибута __bases__, например, выведите родительский класс для созданного класса Class3:
```
Class3.__bases__
>> (<class '__main__.Class2'>,)
Class2.__bases__
>> (<class '__main__.Class1'>,)
Class1.__bases__
>> (<class 'object'>,)
```
Для получения всей цепочки наследования используйте атрибут __mro__:
```
Class3.__mro__
>> (<class '__main__.Class3'>, <class '__main__.Class2'>, <class '__main__.Class1'>, <class 'object'>)
ZeroDivisionError.__mro__
>> (<class 'ZeroDivisionError'>, <class 'ArithmeticError'>, <class 'Exception'>, <class 'BaseException'>, <class 'object'>)
```
#7 Создание свойства класса
Свойство (property) класса – это особый атрибут класса, с которым можно производить операции чтения или задания его значения, а также удаление значения этого атрибута.
Создадим, например, новый класс с определенным в нем свойством
```
class Class4: 
    def __init__(sam,znach): 
        sam.__prm=znach 
    def chten(sam): 
        return sam.__prm 
    def zapis(sam,znch): 
        sam.__prm=znch 
    def stiran(sam): 
        del sam.__prm 
    svojstvo=property(chten,zapis,stiran)
```
Здесь имеется 3 метода: chten, zapis, stiran, которые обслуживают созданное свойство, реализуя операции, соответственно, чтения, записи или удаления значений свойства. Теперь попробуйте некоторые операции с этим свойством 
```
exempl=Class4(12)
exempl.svojstvo
>> 12
exempl.svojstvo=45
print(exempl.svojstvo)
>> 45
del exempl.svojstvo
exempl.svojstvo
>> Traceback (most recent call last):
  File "<pyshell#65>", line 1, in <module>
    exempl.svojstvo
  File "<pyshell#59>", line 5, in chten
    return sam.__prm
AttributeError: 'Class4' object has no attribute '_Class4__prm'
```
#8 Рассмотрите пример представления в виде класса модели системы автоматического регулирования (САР), состоящей из последовательного соединения усилителя и двух инерционных звеньев, охваченных отрицательной обратной связью с усилителем.
Создайте модуль SAU.py с классом:
```
class SAU: 
    def __init__(self,zn_param): 
        self.param=zn_param 
        self.ypr=[0,0] 
    def zdn_zn(self,upr): 
        self.x=upr 
    def model(self): 
        def inerz(x,T,yy): 
            return (x+T*yy)/(T+1) 
        y0=self.x-self.ypr[1]*self.param[3] #Обр.связь с усилителем 2 
        y1=self.param[0]*y0  #Усилитель1 
        y2=inerz(y1,self.param[1],self.ypr[0]) #Инерционное звено1 
        y3=inerz(y2,self.param[2],self.ypr[1]) #Инерционное звено2 
        self.ypr[0]=y2 
        self.ypr[1]=y3 
    def otobraz(self): 
        print('y=',self.ypr[1])
```
Также создадим и выполним программу main_SAU
```
prm=[2.5,4,1.3,0.8] #Параметры модели: коэф.усиления, 2 пост.времени, обратная связь 
from SAU import * 
xx=[0]+[1]*20 #Входной сигнал – «ступенька» 
SAUe=SAU(prm)   # Создаём экземпляр класса 
yt=[] 
for xt in xx:   # Прохождение входного сигнала 
    SAUe.zdn_zn(xt) 
    SAUe.model() 
    SAUe.otobraz() 
    yt.append(SAUe.ypr[1]) 
import pylab 
pylab.plot(yt) 
pylab.show()
>> y= 0.0
y= 0.2173913043478261
y= 0.4763705103969754
y= 0.686594887811293
y= 0.8199324616478645
y= 0.8837201137353929
y= 0.8994188484874774
y= 0.8892777072047301
y= 0.870097963179993
y= 0.8518346102696789
y= 0.8387499784485772
y= 0.8314204114211459
y= 0.8286051955249649
y= 0.8285656555914835
y= 0.8297915186846528
y= 0.8312697736438287
y= 0.8324765218921963
y= 0.8332456979978418
y= 0.8336163607592184
y= 0.8337101315489143
y= 0.833654237067147
```
![](Ris1.png)
